Summary: Spell checker
Name: aspell
Version: 0.60.6.1
Release: 1
# LGPLv2+ .. aspell-0.60.6/misc/po-filter.c, ltmain.sh, modules/speller/default/affix.cpp
# GPLv2+  .. aspell-0.60.6/misc/po-filter.c, aspell-0.60.6/ltmain.sh
# BSD     .. myspell/munch.c
License: LGPLv2 and LGPLv2+ and GPLv2+ and MIT
Group: Applications/Text
URL: http://aspell.net/
Source0: ftp://ftp.gnu.org/gnu/aspell/%{name}-%{version}.tar.gz
Source1: ftp://ftp.gnu.org/gnu/aspell/%{name}-%{version}.tar.gz.sig
Patch0: %{name}-%{version}-aix.patch
Patch7: aspell-0.60.5-pspell_conf.patch
Patch8: aspell-0.60.6-zero.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: gettext, pkg-config, patch
BuildRequires: gcc-c++ >= 4.2.3-2, libstdc++-devel >= 4.2.3-2
Requires: libstdc++ >= 4.2.3-2
Requires: /sbin/install-info, info, gettext

%define _libdir64 %{_prefix}/lib64

%description
GNU Aspell is a spell checker designed to eventually replace Ispell. It can
either be used as a library or as an independent spell checker. Its main
feature is that it does a much better job of coming up with possible
suggestions than just about any other spell checker out there for the
English language, including Ispell and Microsoft Word. It also has many
other technical enhancements over Ispell such as using shared memory for
dictionaries and intelligently handling personal dictionaries when more
than one Aspell process is open at once.

The library is available as 32-bit and 64-bit.


%package devel
Summary: Static libraries and header files for Aspell development
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkg-config
Requires: /sbin/install-info, info

%description devel
Aspell is a spelling checker. The aspell-devel package includes the
static libraries and header files needed for Aspell development.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "g++ -maix64".


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch7 -p1 -b .mlib
%patch8 -p1 -b .zero
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit/


%build
# aspell requires gcc 2.95 (or better) as the C++ compiler
export CC=gcc
export CFLAGS="-DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include"

export CXX=g++
export CXXFLAGS=$CFLAGS

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export CC="gcc -maix64"
export CXX="g++ -maix64"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --enable-shared --disable-static
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export CC="gcc -maix32"
export CXX="g++ -maix32"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --enable-shared --disable-static
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make install DESTDIR=${RPM_BUILD_ROOT}

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
make install DESTDIR=${RPM_BUILD_ROOT}

mv ${RPM_BUILD_ROOT}%{_libdir}/aspell-0.60/ispell ${RPM_BUILD_ROOT}%{_bindir}
mv ${RPM_BUILD_ROOT}%{_libdir}/aspell-0.60/spell ${RPM_BUILD_ROOT}%{_bindir}

/usr/bin/strip X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

gzip --best ${RPM_BUILD_ROOT}%{_infodir}/*.info*
rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done
  cd ${RPM_BUILD_ROOT}%{_libdir64}/%{name}-0.60
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
  cd ${RPM_BUILD_ROOT}%{_libdir}/%{name}-0.60
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/libaspell.a ${RPM_BUILD_ROOT}%{_libdir64}/libaspell.so*
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/libpspell.a ${RPM_BUILD_ROOT}%{_libdir64}/libpspell.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done

  rm -f usr/bin/spell
  mkdir -p usr/linux/bin
  cd usr/linux/bin
  ln -sf ../../../%{_bindir}/spell .
)


%post
if [ -f %{_infodir}/%{name}.info.gz ]; then
    /sbin/install-info %{_infodir}/%{name}.info.gz %{_infodir}/dir --entry="* Aspell: (aspell). "  || : 
fi


%post devel
if [ -f %{_infodir}/%{name}-dev.info.gz ]; then
    /sbin/install-info %{_infodir}/%{name}-dev.info.gz %{_infodir}/dir --entry="* Aspell-dev: (aspell-dev). " || :
fi


%preun
if [ $1 = 0 ]; then
    if [ -f %{_infodir}/%{name}.info.gz ]; then
        /sbin/install-info --delete %{_infodir}/%{name}.info.gz %{_infodir}/dir || :
    fi
fi


%preun devel
if [ $1 = 0 ]; then
    if [ -f %{_infodir}/%{name}-dev.info.gz ]; then
        /sbin/install-info --delete %{_infodir}/%{name}-dev.info.gz %{_infodir}/dir || :
    fi
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/README 32bit/TODO 32bit/COPYING
%{_bindir}/a*
%{_bindir}/ispell
%{_bindir}/pr*
%{_bindir}/run-with-aspell*
%{_bindir}/spell
%{_bindir}/word-list-compress*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_libdir}/%{name}-0.60
%{_libdir64}/%{name}-0.60
%{_infodir}/%{name}.*
%{_mandir}/man1/a*.1
%{_mandir}/man1/prezip-bin.1
%{_mandir}/man1/run-with-aspell.1
%{_mandir}/man1/word-list-compress.1
%{_datadir}/locale/*/*/*
/usr/bin/a*
/usr/bin/ispell
/usr/bin/pr*
/usr/bin/run-with-aspell*
/usr/bin/word-list-compress*
/usr/linux/bin/spell
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%{_bindir}/pspell-config*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/*
%{_libdir64}/pkgconfig/*
%{_infodir}/%{name}-dev.*
%{_mandir}/man1/pspell-config.1
/usr/bin/pspell-config*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Mon Jul 04 2011 Michael Perzl <michael@perzl.org> - 0.60.6.1-1
- updated to version 0.60.6.1

* Mon Nov 22 2010 Michael Perzl <michael@perzl.org> - 0.60.6-1
- first version for AIX V5.1 and higher
